Package com.saxonica.ee.validate

## Class SchemaAttributeTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - com.saxonica.ee.validate.SchemaAttributeTest

- All Implemented Interfaces:
    `java.util.function.Predicate<NodeInfo>`, `SchemaNodeTest`, `ItemType`, `ItemType.WithSequenceTypeCache`

      public class SchemaAttributeTest
      extends NodeTest
      implements SchemaNodeTest

  A NodeTest of the form schema-attribute(attribute-name)
  Since:
    9.3

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.ItemType

      `ItemType.WithSequenceTypeCache`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SchemaAttributeTest​(AttributeDecl attributeDecl)` | Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(java.lang.Object other)` |
    `java.util.Optional<java.lang.String>` | `explainMismatch​(Item item, TypeHierarchy th)` | Get extra diagnostic information about why a supplied item does not conform to this item type, if available.
    `java.lang.String` | `getBasicAlphaCode()` | Get an alphabetic code representing the type, or at any rate, the nearest built-in type from which this type is derived.
    `SchemaType` | `getContentType()` | Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
    `double` | `getDefaultPriority()` | Determine the default priority of this node test when used on its own as a Pattern
    `java.util.function.IntPredicate` | `getMatcher​(NodeVectorTree tree)` | Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test.
    `StructuredQName` | `getNodeName()` |
    `int` | `getPrimitiveType()` | Determine the types of nodes to which this pattern applies.
    `java.util.Optional<IntSet>` | `getRequiredNodeNames()` | Get the set of node names allowed by this NodeTest.
    `UType` | `getUType()` | Get the corresponding `UType`.
    `int` | `hashCode()` | Returns a hash code value for the object.
    `boolean` | `matches​(int nodeKind, NodeName name, SchemaType annotation)` | Test whether this node test is satisfied by a given node.
    `boolean` | `test​(NodeInfo node)` | Test whether this node test is satisfied by a given node.
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `copy, getAtomizedItemType, getFingerprint, getGenre, getMatchingNodeName, getPrimitiveItemType, isAtomicType, isAtomizable, isNillable, isPlainType, matches, one, oneOrMore, toShortString, zeroOrMore, zeroOrOne`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `getFullAlphaCode, getNormalizedDefaultPriority, isTrueItemType, toExportString`

    - ### Methods inherited from interface java.util.function.Predicate

      `and, negate, or`

- - ### Constructor Detail

    - #### SchemaAttributeTest

          public SchemaAttributeTest​(AttributeDecl attributeDecl)
                              throws MissingComponentException

      Constructor
      Parameters:
        `attributeDecl` - The attribute declaration of the named attribute
      Throws:
        `MissingComponentException` - if the type of the attribute is missing from the schema

  - ### Method Detail

    - #### getNodeName

          public StructuredQName getNodeName()

      Specified by:
        `getNodeName` in interface `SchemaNodeTest`

    - #### getUType

          public UType getUType()

      Get the corresponding `UType`. A UType is a union of primitive item types.
      Specified by:
        `getUType` in interface `ItemType`
      Returns:
        the smallest UType that subsumes this item type

    - #### matches

          public boolean matches​(int nodeKind,
                                 NodeName name,
                                 SchemaType annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node test

    - #### getMatcher

          public java.util.function.IntPredicate getMatcher​(NodeVectorTree tree)

      Description copied from class: `NodeTest`
      Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test. (Calling this matcher must give the same result as calling `matchesNode(tree.getNode(nodeNr))`, but it may well be faster).
      Overrides:
        `getMatcher` in class `NodeTest`
      Parameters:
        `tree` - the tree against which the returned function will operate
      Returns:
        an IntPredicate; the matches() method of this predicate takes a node number as input, and returns true if and only if the node identified by this node number matches the node test.

    - #### test

          public boolean test​(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.
      Specified by:
        `test` in interface `java.util.function.Predicate<NodeInfo>`
      Overrides:
        `test` in class `NodeTest`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### getDefaultPriority

          public final double getDefaultPriority()

      Determine the default priority of this node test when used on its own as a Pattern
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Specified by:
        `getDefaultPriority` in class `NodeTest`
      Returns:
        the default priority for the pattern

    - #### getPrimitiveType

          public int getPrimitiveType()

      Determine the types of nodes to which this pattern applies. Used for optimisation. For patterns that match nodes of several types, return Type.NODE
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Overrides:
        `getPrimitiveType` in class `NodeTest`
      Returns:
        the type of node matched by this pattern. e.g. Type.ELEMENT or Type.TEXT

    - #### getRequiredNodeNames

          public java.util.Optional<IntSet> getRequiredNodeNames()

      Get the set of node names allowed by this NodeTest. This is returned as a set of Integer fingerprints. A null value indicates that all names are permitted (i.e. that there are no constraints on the node name. The default implementation returns null.
      Overrides:
        `getRequiredNodeNames` in class `NodeTest`
      Returns:
        the set of integer fingerprints of the node names that this node test can match; or absent if the set of names cannot be represented (for example, with the name tests *:xxx or xxx:*)

    - #### getContentType

          public SchemaType getContentType()

      Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.
      Overrides:
        `getContentType` in class `NodeTest`
      Returns:
        the type annotation that all nodes matching this NodeTest must satisfy

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in interface `ItemType`
      Overrides:
        `toString` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Returns a hash code value for the object.
      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals​(java.lang.Object other)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### getBasicAlphaCode

          public java.lang.String getBasicAlphaCode()

      Description copied from class: `NodeTest`
      Get an alphabetic code representing the type, or at any rate, the nearest built-in type from which this type is derived. The codes are designed so that for any two built-in types A and B, alphaCode(A) is a prefix of alphaCode(B) if and only if A is a supertype of B.
      Specified by:
        `getBasicAlphaCode` in interface `ItemType`
      Overrides:
        `getBasicAlphaCode` in class `NodeTest`
      Returns:
        the alphacode for the nearest containing built-in type

    - #### explainMismatch

          public java.util.Optional<java.lang.String> explainMismatch​(Item item,
                                                                      TypeHierarchy th)

      Get extra diagnostic information about why a supplied item does not conform to this item type, if available. If extra information is returned, it should be in the form of a complete sentence, minus the closing full stop. No information should be returned for obvious cases.
      Specified by:
        `explainMismatch` in interface `ItemType`
      Overrides:
        `explainMismatch` in class `NodeTest`
      Parameters:
        `item` - the item that doesn't match this type
        `th` - the type hierarchy cache
      Returns:
        optionally, a message explaining why the item does not match the type